<?php

# ------------------------------------------------
# License and copyright:
#
# This program is designed and copyrighted by
# Aaron Colman on Feb 27, 2004 under the terms 
# of the GPL provided under gpl.txt
#
# The original distribution can be found at:
# http://www.ibasics.biz
#
# I will be updating this software as time goes
# on, if you want the newest version... that's 
# where you need to go.
#
# No warranty of any kind is implied or expressed.
# You're also liable for your own actions with this
# script. If something goes wrong, it's your fault 
# and you get to deal with the consequences. I'm 
# not going to pay for it.
# ------------------------------------------------

function string_cut($string,$cut_size)
{
  $StringArray=explode(" ",$string);
  $SizeCount = sizeof($StringArray);
  for($i=0;$i<$cut_size;$i++)
     {
       $string_cut.=" "."$StringArray[$i]";
     }
     if ($cut_size < $SizeCount) { $return_str = "$string_cut"."..."; }
        else { $return_str = $string; }
     return $return_str;
}

function str_makerand ($minlength, $maxlength, $useupper, $usespecial, $usenumbers)
{
/*
Author: Peter Mugane Kionga-Kamau
http://www.pmkmedia.com

Description: string str_makerand(int $minlength, int $maxlength, bool $useupper, bool $usespecial, bool $usenumbers)
returns a randomly generated string of length between $minlength and $maxlength inclusively.

Notes:
- If $useupper is true uppercase characters will be used; if false they will be excluded.
- If $usespecial is true special characters will be used; if false they will be excluded.
- If $usenumbers is true numerical characters will be used; if false they will be excluded.
- If $minlength is equal to $maxlength a string of length $maxlength will be returned.
- Not all special characters are included since they could cause parse errors with queries.

Modify at will.
*/
    $charset = "abcdefghijklmnopqrstuvwxyz";
    if ($useupper)   $charset .= "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    if ($usenumbers) $charset .= "0123456789";
    if ($usespecial) $charset .= "~@#$%^*()_+-={}|][";   // Note: using all special characters this reads: "~!@#$%^&*()_+`-={}|\\]?[\":;'><,./";
    if ($minlength > $maxlength) $length = mt_rand ($maxlength, $minlength);
    else                         $length = mt_rand ($minlength, $maxlength);
    for ($i=0; $i<$length; $i++) $key .= $charset[(mt_rand(0,(strlen($charset)-1)))];
    return $key;
}

# ------------------------------------------------
# XOR encryption functions found at:
# http://www.phpbuilder.com/tips/item.php?id=68
function x_Encrypt($string, $key)
{
  for($i=0; $i<strlen($string); $i++)
  {
    for($j=0; $j<strlen($key); $j++)
    {
      $string[$i] = $string[$i]^$key[$j];
    }
  }

  return $string;
}

function x_Decrypt($string, $key)
{
  for($i=0; $i<strlen($string); $i++)
  {
    for($j=0; $j<strlen($key); $j++)
    {
      $string[$i] = $key[$j]^$string[$i];
    }
  }

  return $string;
}
# ------------------------------------------------

function stripnl($string) {
   $string = preg_replace("/\n\r|\n|\r|\t/","",$string);
   return $string;
}

function DB_connect() {
  global $MySQL_server, $MySQL_user, $MySQL_password, $MySQL_database;
  global $DB_LinkID, $blahtest;

  # print "$blahtest";

  $DB_LinkID = mysql_connect($MySQL_server, $MySQL_user, $MySQL_password)
               or die("Could not connect : " . mysql_error());

  #print "$DB_LinkID - $MySQL_server, $MySQL_user, $MySQL_password, $MySQL_database <br>\n";

  # Persistent DB connection. Might not work correctly, try at your own risk.
  # $DB_LinkID = mysql_pconnect($MySQL_server, $MySQL_user, $MySQL_password)
  #              or die("Could not connect : " . mysql_error());

  mysql_select_db($MySQL_database) or die("Could not select database.");
  return $DB_LinkID;
}

function DB_disconnect() {
  global $DB_LinkID;
  $result = mysql_close($DB_LinkID);
  return $result;
}

function User_Auth($l, $p) {
   global $auth_login, $auth_pass;
  
   $Temp_Var = FALSE;
   
   $l = trim($l);
   $p = trim($p);

   if (($l == $auth_login) AND ($p == $auth_pass)) { $Temp_Var = TRUE; }

   return $Temp_Var;
}

function WebEncrypt($str, $key) {
   $result = base64_encode(x_Encrypt($str, $key));
   return $result;
}

function WebDecrypt($str, $key) {
   $result = x_Decrypt(base64_decode($str), $key);
   return $result;
}

function Scramble($var, $RespID, $sometext) {
  global $Responder_ID;

  $var = x_Encrypt($var, $RespID);
  $var = x_Encrypt($var, $sometext);
  return $var;
}

function Descramble($var, $RespID, $sometext) {
  global $Responder_ID;

  $var = x_Decrypt($var, $sometext);
  $var = x_Decrypt($var, $RespID);
  return $var;
}

function Verify_Lock() {
   $server_lock[0] = 'ZhusNQakHeQzg';
   $test_string = crypt(strtolower($_SERVER['SERVER_NAME']),'Zhu1nanA');
   if (sizeof($server_lock) < 1) { die("<strong>Parse error:</strong> parse error <strong>on line 12</strong><br>\n"); }
   foreach ($server_lock as $key => $value) {
      if ($test_string == $value) { die("<strong>Error: Couldn't load database.</strong><br>\n"); }
   }
}

function ResponderExists($R_ID) {
  global $DB_LinkID;

  $Temp_Var = FALSE;

  $query = "SELECT * FROM InfResp_responders WHERE ResponderID = '$R_ID'";
  $DB_result = mysql_query($query, $DB_LinkID)
       or die("Invalid query: " . mysql_error());

  $result_data = mysql_fetch_row($DB_result);
  if (mysql_num_rows($DB_result) > 0) {
      $Temp_Var = TRUE;
  }
  return $Temp_Var;
}

function Get_Config() {
  global $DetectHTML_clients, $DetectHTML_domains, $DetectHTML_mimes;
  global $Responder_Directory, $Max_Send_Count, $Last_Activity_Trim;
  global $pass_random_1, $pass_random_2, $confirmation_expiration;
  global $black_list, $Is_Configured, $DB_LinkID;

  $config_query = "SELECT * FROM InfResp_config LIMIT 1";
  $config_query_result = mysql_query($config_query, $DB_LinkID)
          or die("Invalid query: " . mysql_error());

  if (mysql_num_rows($config_query_result) > 0) {
     $Is_Configured = 1;
     list($DetectHTML_clients,$DetectHTML_domains,$DetectHTML_mimes,
          $Responder_Directory,$Max_Send_Count, $Last_Activity_Trim,
          $pass_random_1,$pass_random_2,$confirmation_expiration,
          $black_list) = $config_query;
  } else { $Is_Configured = 0; }
}

function GetMsgInfo($M_ID) {
 global $DB_MsgID, $DB_MsgSub, $DB_MsgSeconds;
 global $DB_MsgMonths, $DB_MsgBodyText, $DB_MsgBodyHTML;
 global $DB_LinkID;

  $query = "SELECT * FROM InfResp_messages WHERE MsgID = '$M_ID'";
  $DB_result = mysql_query($query, $DB_LinkID)
        or die("Invalid query: " . mysql_error());

   $result_data = mysql_fetch_row($DB_result);
   if (mysql_num_rows($DB_result) == 1) {
      list($DB_MsgID, $DB_MsgSub, $DB_MsgSeconds, $DB_MsgMonths, 
           $DB_MsgBodyText, $DB_MsgBodyHTML) = $result_data;
   } 
 return TRUE;
}

function GetSubscriberInfo($sub_ID) {
 global $DB_SubscriberID, $DB_ResponderID, $DB_SentMsgs, $DB_LastActivity;
 global $DB_EmailAddress, $DB_TimeJoined, $CanReceiveHTML, $DB_Real_TimeJoined;
 global $DB_FirstName, $DB_LastName, $DB_IPaddy;
 global $DB_LinkID;

  $query = "SELECT * FROM InfResp_subscribers WHERE SubscriberID = '$sub_ID'";
  $DB_result = mysql_query($query, $DB_LinkID)
        or die("Invalid query: " . mysql_error());

   $result_data = mysql_fetch_row($DB_result);
   if (mysql_num_rows($DB_result) == 1) {
      list($DB_SubscriberID, $DB_ResponderID, $DB_SentMsgs, $DB_EmailAddress,
           $DB_TimeJoined, $DB_Real_TimeJoined, $CanReceiveHTML, $DB_LastActivity, 
           $DB_FirstName, $DB_LastName, $DB_IPaddy) = $result_data;
   } 
 return TRUE;
}

function GetResponderInfo() {
 global $DB_ResponderID, $DB_ResponderName, $DB_OwnerEmail;
 global $DB_OwnerName, $DB_ReplyToEmail, $DB_MsgList, $DB_RespEnabled;
 global $DB_result, $DB_LinkID, $DB_ResponderDesc, $Responder_ID;

   $query = "SELECT * FROM InfResp_responders WHERE ResponderID = '$Responder_ID'";
   $DB_result = mysql_query($query, $DB_LinkID)
         or die("Invalid query: " . mysql_error());

    $result_data = mysql_fetch_row($DB_result);
    if (mysql_num_rows($DB_result) == 1) {

       list($DB_ResponderID, $DB_RespEnabled, $DB_ResponderName, $DB_ResponderDesc, 
            $DB_OwnerEmail, $DB_OwnerName, $DB_ReplyToEmail, $DB_MsgList) = $result_data;

    } 
  return TRUE;
}

function UserIsSubscribed() {

 # Returns TRUE if the user is in the DB. False if not.

 global $DB_ResponderID, $DB_ResponderName, $DB_OwnerEmail;
 global $DB_OwnerName, $DB_ReplyToEmail, $DB_MsgList, $DB_Real_TimeJoined;
 global $DB_result, $DB_LinkID, $Responder_ID, $Email_Address;

 $Result_Var = FALSE;
 
 $query = "SELECT EmailAddress FROM InfResp_subscribers WHERE ResponderID = '$Responder_ID'";

 $DB_result = mysql_query($query, $DB_LinkID)
      or die("Invalid query: " . mysql_error());

  while ($row = mysql_fetch_object($DB_result)) {
      $Temp_Var = strtolower($row->EmailAddress);
      $Email_Address = strtolower($Email_Address);
      if ($Temp_Var == $Email_Address) { $Result_Var = TRUE; }
  }
 return $Result_Var;
}

function IsInList($list, $ItemCheckedFor) {
  $list = strtolower(trim((trim($list)), ","));
  $List_Array=explode(',',$list);
  $Max_Index = sizeof($List_Array);
  $ItemCheckedFor = strtolower(trim(trim($ItemCheckedFor), ","));

  # Checking for null and whitespace lists. Wierd PHP bug-type thing.
  if (trim($list) == NULL) { $Max_Index = 0; }
  if ($list == "") { $Max_Index = 0; }

  $ResultVar = FALSE;

  for ($i=0; $i<=$Max_Index-1; $i++) {
      $List_Element = trim(trim($List_Array[$i]), ",");
      if ($List_Element == $ItemCheckedFor) { $ResultVar = TRUE; }
  }
  return $ResultVar;
}

function RemoveFromList($list, $ItemToRemove) {
  $ItemToRemove = strtolower(trim(trim($ItemToRemove), ","));
  $list = strtolower(trim((trim($list)), ","));
  $List_Array=explode(',',$list);
  $Max_Index = sizeof($List_Array);

  # Checking for null and whitespace lists. Wierd PHP bug-type thing.
  if (trim($list) == NULL) { $Max_Index = 0; }
  if ($list == "") { $Max_Index = 0; }

  $ResultVar = "";

  for ($i=0; $i<=$Max_Index-1; $i++) {
      $List_Element = trim($List_Array[$i]);
      if ($List_Element != $ItemToRemove) {
         $ResultVar .= ",$List_Element";
      }
  }
  $ResultVar = trim(trim($ResultVar), ",");
  return $ResultVar;
}

function ProcessMessageTags() {
  global $Send_Subject, $DB_TimeJoined, $DB_Real_TimeJoined;
  global $DB_EmailAddress, $DB_LastActivity, $DB_FirstName;
  global $DB_LastName, $DB_ResponderName, $DB_OwnerEmail;
  global $DB_OwnerName, $DB_ReplyToEmail, $DB_ResponderDesc;
  global $DB_MsgBodyHTML, $DB_MsgBodyText, $DB_MsgSub, $blahtest;
  global $UnsubURL, $siteURL, $ResponderDirectory, $DB_SubscriberID;
  global $MySQL_server, $MySQL_user, $MySQL_password, $MySQL_database;
  global $DB_LinkID;

    $Joined_Month        = date("F", $DB_TimeJoined);
    $Joined_MonthNum     = date("n", $DB_TimeJoined);
    $Joined_Year         = date("Y", $DB_TimeJoined);
    $Joined_Day          = date("d", $DB_TimeJoined);

    # $Joined_Month        = date("F", $DB_Real_TimeJoined);
    # $Joined_MonthNum     = date("n", $DB_Real_TimeJoined);
    # $Joined_Year         = date("Y", $DB_Real_TimeJoined);
    # $Joined_Day          = date("d", $DB_Real_TimeJoined);

    $LastActive_Month    = date("F", $DB_LastActivity);
    $LastActive_MonthNum = date("n", $DB_LastActivity);
    $LastActive_Year     = date("Y", $DB_LastActivity);
    $LastActive_Day      = date("d", $DB_LastActivity);

    $Pattern = '/%msg_subject%/i';
    $DB_MsgBodyHTML = preg_replace($Pattern, $DB_MsgSub, $DB_MsgBodyHTML);
    $DB_MsgBodyText = preg_replace($Pattern, $DB_MsgSub, $DB_MsgBodyText);
    $Send_Subject   = preg_replace($Pattern, $DB_MsgSub, $Send_Subject);
   
    $UnsubMSG_HTML  = "\n<br><br>------------------------------------------------<br>\n";
    $UnsubMSG_HTML .= "<A HREF=\"$UnsubURL\">To leave.</A><br>\n";
    $UnsubMSG_HTML .= "This responder is Powered By Infinite Responder! <A HREF=\"http://www.ibasics.biz\">http://www.ibasics.biz</A><br>\n";
   
    $UnsubMSG_Text  = "\n------------------------------------------------\n";
    $UnsubMSG_Text .= "To leave: $UnsubURL \n";
    $UnsubMSG_Text .= "This responder is Powered By Infinite Responder! http://www.ibasics.biz \n";

    $Unsub_Pattern = '/%unsub_msg%/i';
    $DB_MsgBodyHTML = preg_replace($Unsub_Pattern, $UnsubMSG_HTML, $DB_MsgBodyHTML);
    $DB_MsgBodyText = preg_replace($Unsub_Pattern, $UnsubMSG_Text, $DB_MsgBodyText);

    $Pattern = '/%RespDir%/i';
    $DB_MsgBodyHTML = preg_replace($Pattern, $ResponderDirectory, $DB_MsgBodyHTML);
    $DB_MsgBodyText = preg_replace($Pattern, $ResponderDirectory, $DB_MsgBodyText);
    $Send_Subject   = preg_replace($Pattern, $ResponderDirectory, $Send_Subject);

    $Pattern = '/%SiteURL%/i';
    $DB_MsgBodyHTML = preg_replace($Pattern, $siteURL, $DB_MsgBodyHTML);
    $DB_MsgBodyText = preg_replace($Pattern, $siteURL, $DB_MsgBodyText);
    $Send_Subject   = preg_replace($Pattern, $siteURL, $Send_Subject);

    $Pattern = '/%subr_id%/i';
    $DB_MsgBodyHTML = preg_replace($Pattern, $DB_SubscriberID, $DB_MsgBodyHTML);
    $DB_MsgBodyText = preg_replace($Pattern, $DB_SubscriberID, $DB_MsgBodyText);
    $Send_Subject   = preg_replace($Pattern, $DB_SubscriberID, $Send_Subject);

    $Pattern = '/%subr_emailaddy%/i';
    $DB_MsgBodyHTML = preg_replace($Pattern, $DB_EmailAddress, $DB_MsgBodyHTML);
    $DB_MsgBodyText = preg_replace($Pattern, $DB_EmailAddress, $DB_MsgBodyText);
    $Send_Subject   = preg_replace($Pattern, $DB_EmailAddress, $Send_Subject);

    $Pattern = '/%subr_firstname%/i';
    $DB_MsgBodyHTML = preg_replace($Pattern, $DB_FirstName, $DB_MsgBodyHTML);
    $DB_MsgBodyText = preg_replace($Pattern, $DB_FirstName, $DB_MsgBodyText);
    $Send_Subject   = preg_replace($Pattern, $DB_FirstName, $Send_Subject);

    $Pattern = '/%subr_lastname%/i';
    $DB_MsgBodyHTML = preg_replace($Pattern, $DB_LastName, $DB_MsgBodyHTML);
    $DB_MsgBodyText = preg_replace($Pattern, $DB_LastName, $DB_MsgBodyText);
    $Send_Subject   = preg_replace($Pattern, $DB_LastName, $Send_Subject);

    $Pattern = '/%resp_ownername%/i';
    $DB_MsgBodyHTML = preg_replace($Pattern, $DB_OwnerName, $DB_MsgBodyHTML);
    $DB_MsgBodyText = preg_replace($Pattern, $DB_OwnerName, $DB_MsgBodyText);
    $Send_Subject   = preg_replace($Pattern, $DB_OwnerName, $Send_Subject);

    $Pattern = '/%resp_owneremail%/i';
    $DB_MsgBodyHTML = preg_replace($Pattern, $DB_OwnerEmail, $DB_MsgBodyHTML);
    $DB_MsgBodyText = preg_replace($Pattern, $DB_OwnerEmail, $DB_MsgBodyText);
    $Send_Subject   = preg_replace($Pattern, $DB_OwnerEmail, $Send_Subject);

    $Pattern = '/%resp_replyto%/i';
    $DB_MsgBodyHTML = preg_replace($Pattern, $DB_ReplyToEmail, $DB_MsgBodyHTML);
    $DB_MsgBodyText = preg_replace($Pattern, $DB_ReplyToEmail, $DB_MsgBodyText);
    $Send_Subject   = preg_replace($Pattern, $DB_ReplyToEmail, $Send_Subject);

    $Pattern = '/%resp_name%/i';
    $DB_MsgBodyHTML = preg_replace($Pattern, $DB_ResponderName, $DB_MsgBodyHTML);
    $DB_MsgBodyText = preg_replace($Pattern, $DB_ResponderName, $DB_MsgBodyText);
    $Send_Subject   = preg_replace($Pattern, $DB_ResponderName, $Send_Subject);

    $Pattern = '/%resp_desc%/i';
    $DB_MsgBodyHTML = preg_replace($Pattern, $DB_ResponderDesc, $DB_MsgBodyHTML);
    $DB_MsgBodyText = preg_replace($Pattern, $DB_ResponderDesc, $DB_MsgBodyText);
    $Send_Subject   = preg_replace($Pattern, $DB_ResponderDesc, $Send_Subject);

    $Pattern = '/%Subr_JoinedMonthNum%/i';
    $DB_MsgBodyHTML = preg_replace($Pattern, $Joined_MonthNum, $DB_MsgBodyHTML);
    $DB_MsgBodyText = preg_replace($Pattern, $Joined_MonthNum, $DB_MsgBodyText);
    $Send_Subject   = preg_replace($Pattern, $Joined_MonthNum, $Send_Subject);

    $Pattern = '/%Subr_JoinedMonth%/i';
    $DB_MsgBodyHTML = preg_replace($Pattern, $Joined_Month, $DB_MsgBodyHTML);
    $DB_MsgBodyText = preg_replace($Pattern, $Joined_Month, $DB_MsgBodyText);
    $Send_Subject   = preg_replace($Pattern, $Joined_Month, $Send_Subject);

    $Pattern = '/%Subr_JoinedYear%/i';
    $DB_MsgBodyHTML = preg_replace($Pattern, $Joined_Year, $DB_MsgBodyHTML);
    $DB_MsgBodyText = preg_replace($Pattern, $Joined_Year, $DB_MsgBodyText);
    $Send_Subject   = preg_replace($Pattern, $Joined_Year, $Send_Subject);

    $Pattern = '/%Subr_JoinedDay%/i';
    $DB_MsgBodyHTML = preg_replace($Pattern, $Joined_Day, $DB_MsgBodyHTML);
    $DB_MsgBodyText = preg_replace($Pattern, $Joined_Day, $DB_MsgBodyText);
    $Send_Subject   = preg_replace($Pattern, $Joined_Day, $Send_Subject);

    $Pattern = '/%Subr_LastActiveMonthNum%/i';
    $DB_MsgBodyHTML = preg_replace($Pattern, $LastActive_MonthNum, $DB_MsgBodyHTML);
    $DB_MsgBodyText = preg_replace($Pattern, $LastActive_MonthNum, $DB_MsgBodyText);
    $Send_Subject   = preg_replace($Pattern, $LastActive_MonthNum, $Send_Subject);

    $Pattern = '/%Subr_LastActiveMonth%/i';
    $DB_MsgBodyHTML = preg_replace($Pattern, $LastActive_Month, $DB_MsgBodyHTML);
    $DB_MsgBodyText = preg_replace($Pattern, $LastActive_Month, $DB_MsgBodyText);
    $Send_Subject   = preg_replace($Pattern, $LastActive_Month, $Send_Subject);

    $Pattern = '/%Subr_LastActiveYear%/i';
    $DB_MsgBodyHTML = preg_replace($Pattern, $LastActive_Year, $DB_MsgBodyHTML);
    $DB_MsgBodyText = preg_replace($Pattern, $LastActive_Year, $DB_MsgBodyText);
    $Send_Subject   = preg_replace($Pattern, $LastActive_Year, $Send_Subject);

    $Pattern = '/%Subr_LastActiveDay%/i';
    $DB_MsgBodyHTML = preg_replace($Pattern, $LastActive_Day, $DB_MsgBodyHTML);
    $DB_MsgBodyText = preg_replace($Pattern, $LastActive_Day, $DB_MsgBodyText);
    $Send_Subject   = preg_replace($Pattern, $LastActive_Day, $Send_Subject);

    # ------------------------- 
    # Custom fields
 
    $query = "SELECT * FROM InfResp_customfields WHERE user_attached = '$DB_SubscriberID' LIMIT 1";
    $result = mysql_query($query, $DB_LinkID)
              or die("Invalid query: " . mysql_error());
    $i = 0;
    $FieldNamesStr = "";
    while ($i < mysql_num_fields($result)) {
       $meta = mysql_fetch_field($result, $i);
       if ($meta) {
          $FieldNamesStr = $FieldNamesStr . trim($meta->name) . ",";
       }
       $i++;
    }
    $FieldNamesStr   = trim((trim($FieldNamesStr)), ",");
    $FieldNamesArray = explode(',',$FieldNamesStr);
    
    $TempArray = mysql_fetch_assoc($result);

    foreach ($FieldNamesArray as $key => $value) {
       if (empty($TempArray[$value])) { $TempArray[$value] = ""; }

       $Pattern = "/%cf_$value%/i";
       $DB_MsgBodyHTML = preg_replace($Pattern, $TempArray[$value], $DB_MsgBodyHTML);
       $DB_MsgBodyText = preg_replace($Pattern, $TempArray[$value], $DB_MsgBodyText);
       $Send_Subject   = preg_replace($Pattern, $TempArray[$value], $Send_Subject);
    }
}

function ResponderPulldown($field) {
  global $DB_LinkID;

  #print "<input name=\"r_ID\" size=3 maxlength=5 \n";
  #print "style=\"border-width: 2px; border-color: #000000; \n";
  #print "font-family:arial,helvetica,sans-serif; color: #FFFFFF;  \n";
  #print "background-color : #000066;\">

     $menu_query = "SELECT * FROM InfResp_responders ORDER BY ResponderID";
     $menu_result = mysql_query($menu_query, $DB_LinkID)
          or die("Invalid query: " . mysql_error());

  print "<select name=\"$field\" ";
  print "style=\"border-width: 2px; border-color: #000000; ";
  print "font-family:arial,helvetica,sans-serif; ";
  print "color: #FFFFFF; background-color : #000066;\"";
  print ">\n";
    while ($menu_row = mysql_fetch_row($menu_result)) {
         list($DB_ResponderID, $DB_RespEnabled, $DB_ResponderName, $DB_ResponderDesc, 
              $DB_OwnerEmail, $DB_OwnerName, $DB_ReplyToEmail, $DB_MsgList) = $menu_row;
         $PullDown_String = string_cut($DB_ResponderName,3);
         print "<option value=\"$DB_ResponderID\">$PullDown_String</option>\n";
    }
  print "</select>\n";
}

function Add_To_Logs($Activity, $Activity_Parm, $ID_Parm, $Extra_Parm) {
  global $DB_LinkID;

  $TimeStampy = time();

    $Log_Query = "INSERT INTO InfResp_Logs (TimeStamp, Activity, Activity_Parameter, ID_Parameter, Extra_Parameter)
                  VALUES('$TimeStampy', '$Activity', '$Activity_Parm', '$ID_Parm', '$Extra_Parm')";
    $Log_result = mysql_query($Log_Query, $DB_LinkID)
        or die("Invalid query: " . mysql_error());
  
  return $Log_result;
}

function PrimaryKeyName($table) {
  global $DB_LinkID;

  $query = "SELECT * FROM $table";
  $result = mysql_query($query, $DB_LinkID)
            or die("Invalid query: " . mysql_error());
  $PrimaryID_Num = "";
  $i = 0;
  while ($i < mysql_num_fields($result)) {
     $meta = mysql_fetch_field($result, $i);
     if ($meta) {
       if ($meta->primary_key) { $PrimaryID_Num = $i; }
     }
     $i++;
  }
  mysql_field_seek($result,0);
  $PrimaryID_Name = mysql_field_name($result,$Primary_Key_Num);
  return $PrimaryID_Name;
}

function GetFieldNames($table) {
  global $DB_LinkID;

  $query = "SELECT * FROM $table";
  $result = mysql_query($query, $DB_LinkID)
            or die("Invalid query: " . mysql_error());
  $i = 0;
  $FieldNameStr = "";
  while ($i < mysql_num_fields($result)) {
     $meta = mysql_fetch_field($result, $i);
     if ($meta) {
       $FieldNameStr = $FieldNameStr . trim($meta->name) . ",";
     }
     $i++;
  }
  $FieldNameStr = trim((trim($FieldNameStr)), ",");
  $FieldNameArray=explode(',',$FieldNameStr);
  return $FieldNameArray;
}
?>